#define  UART_GLOBAL
#include  "uart_nano.h"

#define  UART_CTL_DATA_WAKE_EN	   0x00000200

////UART0 Initial ///////////////////////////////////////////////////////////////////////
void UART0_Init(uint32_t Baud)                 
{  
  UART0->FUN_SEL = 0 ;                           //UART mode                                
  UART0->TLCTL   = 0x3203 ;                      //8bit 1-stop no parity RTS:14,RxFiFo:8   
  UART0->BAUD    = 12000000/Baud - 1 ;           //UATR_CLK has been selected 22M  
  UART0->TMCTL   = 0x00000FF ;                   //Max reception interval 256bit
}
void UART1_Init(uint32_t Baud)                 
{  
  UART1->FUN_SEL = 3 ;                           // 485 mode                         
  UART1->TLCTL   = 0x3303 ;                      //8bit 1-stop no parity RTS:14,RxFiFo:14   
  UART1->BAUD    = 12000000/Baud - 1 ;           //UATR_CLK has been selected 22M  
  UART1->TMCTL   = 0x000000FF ;                  //Max reception interval 256bit
  UART1->IER     = UART_IER_RTO_IE | UART_IER_RDA_IE ;  //enable receive IRQ  
  UART1->CTL     = UART_CTL_DATA_WAKE_EN | UART_CTL_AUTO_CTS_EN | UART_CTL_AUTO_RTS_EN ; 
  UART1->ALT_CTL = (0x47<<24) | UART_ALT_CTL_RS485_ADD_EN | UART_ALT_CTL_RS485_AAD | UART_ALT_CTL_RS485_AUD ;      //ַΪ0x47,G
  NVIC_SetPriority(UART1_IRQn, 2) ;  
  NVIC->ISER[0]  = 1 << UART1_IRQn ;
}

//// To fill TX FIFO with character, print character ////////////////////////////////////
// input :  *pStr,  string pointer.
//           Cnt,   character Number of string.
// return:   pStr,  First address of remaind character. Used for next time printing.
//           0,     All character has been printed.
uint8_t* Tx0FillFiFo(uint8_t*pStr, uint32_t Cnt)
{  
  while(Cnt){       
    if(UART0->FSR & UART_FSR_TX_FULL_F) break ;              
	  UART0->THR = *pStr++ ;    
		--Cnt ;  
  }  
  if(Cnt)return pStr ;  
  else  return 0 ;
}


void UART1_IRQHandler(void)
{    
  if(UART1->ISR & (UART_ISR_RDA_IS | UART_ISR_RTO_IS)){        //receive IRQ    
    while(!(UART1->FSR & UART_FSR_RX_EMPTY_F)){
      if(UART1->FSR & UART_FSR_FE_F) GPIOE->DOUT ^= 0x40 ;     //ָ֡ʾ
      *pRx0 = UART1->RBR ; 
      if(pRx0 < pEndRx0) ++pRx0 ;
    }      
  }
}
